package com.novaordis.thread194629.distrib;

import java.util.concurrent.Callable;

import org.apache.log4j.Logger;
import org.infinispan.Cache;

/**
 * @author <a href="mailto:ovidiu@novaordis.com">Ovidiu Feodorov</a>
 *
 * Copyright 2012 Nova Ordis LLC
 */
class RWDistributableWritesMultiThreaded implements  Callable<Long>
{
    private final Cache<Object, Object> sourceCache;
    private final Cache<Object, Object> destinationCache;
    private final String key;
    private static final Logger log = Logger.getLogger(RWDistributableWritesMultiThreaded.class);

    RWDistributableWritesMultiThreaded(final Cache<Object, Object> sourceCache, Cache<Object, Object> destinationCache, final String key)
    {
        this.sourceCache = sourceCache;
        this.destinationCache = destinationCache;
        this.key = key;
    }

	public Long call() throws Exception {		
        String value = (String) sourceCache.get(key);
        log.info("read from SourceCache for key: "+key+ " value: " + value);

        destinationCache.put(key, value);

        String destVal = (String) destinationCache.get(key);

        log.info("Successfully put in destinationCache (key, value):  ("+ key + ", " + destVal + ")");

        if (!key.equals(destVal) || !value.equals(destVal))
        {
            throw new RuntimeException("we did not get what we put into the cache");
        }
		return new Long(1);
	}
}
