package com.novaordis.thread194629.distrib;

import java.util.concurrent.Callable;

import org.apache.log4j.Logger;
import org.infinispan.Cache;

/**
 * @author <a href="mailto:ovidiu@novaordis.com">Ovidiu Feodorov</a>
 *
 * Copyright 2012 Nova Ordis LLC
 */
class RWDistributableWritesSingleThreaded implements  Callable<String>
{
    private final Cache<Object, Object> sourceCache;
    private final String key;
    private static final Logger log = Logger.getLogger(RWDistributableWritesSingleThreaded.class);

    RWDistributableWritesSingleThreaded(final Cache<Object, Object> sourceCache, final String key)
    {
        this.sourceCache = sourceCache;
        this.key = key;
    }

	@Override
	public String call() throws Exception {
        String value = (String) sourceCache.get(key);
        log.info("read from SourceCache for key: "+key+ " value: " + value);

        if (!value.equals(key))
        {
            throw new RuntimeException("Source Cache isn't populated correctly - INCORRECT TEST");
        }
		return value;
	}
}
